  // select next Ready task

  repeat
{$IFDEF OS_ALWAYS}
    if OS_AlwaysProcedure <> nil then OS_AlwaysProcedure^;
{$ENDIF}
    Select_Next_Task;
  until CurrentTask <> OS_NO_TASK;


  // disable interrupts
  OldSR := SR;
  SR    := SR or $E0;

  // Change State
  TaskData[CurrentTask]._State := st_RUNNING; // this task is running now

  // restore context
  
  Restore_Context;
  asm
    ; -------- place the return address on the stack (W0 and W1 are used here)
    mov W15, W0                               ; StackPtr_ := ^word(W15);
    dec W0                                    ; dec(StackPtr_);
    dec W0
    mov #lo_addr(CRTOS_TmpRegs), W1           ; StackPtr_^ := TmpPCH;
    Add #36, W1
    mov [W1++], [W0--]                        ; dec(StackPtr_);
    mov [W1], [W0]                            ; StackPtr_^ := TmpPCL;

    ; --------- restore W0 and W1 ------------
    mov CRTOS_TmpRegs, W0                     ; restore W0
    mov CRTOS_TmpRegs + 2, W1                 ; restore W1   
  end;

  // enable interrupts
  SR := OldSr;